-- register.lua by Ian898
-- script by (Discord) Unangenehmer#9659
-- Date 31.08.2020

--[[
Changelog Version 1.0.0.1:
- Description adapted
- New icon
- Day limit adapts to the Seasons-Mod
- Engine may fail to start when starting the motor after reaching the limit
- Engine can stall if engine load is too high
- Bugs fixed when servicing several times
- No longer subtracts engine hours and age on first load
- Fixed a bug with "bulk buy mod" (pallet could not be bought)
- Fixed multiplayer problems



Changelog Version 1.0.0.2:
- Fixed FPS problems
- Fixed dedicated server problems
- Removed the light from the lamp
- Description slightly adapted
- Fixed a bug, where the hotkey to maintenance did not appear
--]]

-- THANKS YOU FOR THE REGISTER.LUA IAN! 

registerExtendedVehicleMaintenance = {}
registerExtendedVehicleMaintenance.specName = "ExtendedVehicleMaintenance"
registerExtendedVehicleMaintenance.className = "ExtendedVehicleMaintenance"
registerExtendedVehicleMaintenance.fileName = g_currentModDirectory.."ExtendedVehicleMaintenance.lua"

function registerExtendedVehicleMaintenance:registerSpecialization()

	local specName = registerExtendedVehicleMaintenance.specName

	if g_specializationManager:getSpecializationByName(specName) == nil then
		g_specializationManager:addSpecialization(registerExtendedVehicleMaintenance.specName, registerExtendedVehicleMaintenance.className, registerExtendedVehicleMaintenance.fileName, true, nil)

		for vehicleType, vehicle in pairs(g_vehicleTypeManager.vehicleTypes) do

			if vehicle ~= nil and vehicleType ~= "locomotive" and vehicleType ~= "woodCrusherTrailerDrivable" then

				local isDrivable = false;
				local hasTBO = false;
				local hasNotEVM = true;

				for name, spec in pairs(vehicle.specializationsByName) do

					if name == "drivable" then
						isDrivable = true;
					elseif name == "tensionBeltObject" then
						hasTBO = true;
					elseif name == "ExtendedVehicleMaintenance" then
						hasNotEVM = false;
					end
				end

				if hasNotEVM and isDrivable or hasTBO then
					print("  adding ExtendedVehicleMaintenance to vehicleType '"..tostring(vehicleType).."'")

					local specObject = g_specializationManager:getSpecializationObjectByName(specName);

					vehicle.specializationsByName[specName] = specObject;
					table.insert(vehicle.specializationNames, specName);
					table.insert(vehicle.specializations, specObject);
				end
			end
		end
	end
end
registerExtendedVehicleMaintenance:registerSpecialization()

-- make localizations available
local i18nTable = getfenv(0).g_i18n
for l18nId,l18nText in pairs(g_i18n.texts) do
  i18nTable:setText(l18nId, l18nText)
end